﻿@using Microsoft.Extensions.Localization
@using ElectronNET.API
@using ElectronNET.API.Entities
@using OTaskForce.Singletons

@inject IJSRuntime _jsRuntime
@inject NavigationManager _navigationManager
@inject IStringLocalizer<OpenProjectModal> _localizer
@inject ProjectsOperator _projectsOperator

<div class="modal fade" id="OpenProjectModal" tabindex="-1">
    <div class="modal-dialog modal-dialog-centered modal-dialog-scrollable">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">@_localizer["Відкрити проєкт"]</h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal"></button>
            </div>
            <div class="modal-body p-0">
                <div class="table-responsive m-0">
                    <table class="table table-hover m-0">
                        <tbody>
                        @if (_recentProjectsList == null)
                        {
                            <tr>
                                <td class="p-2"><span class="text-nowrap text-truncate">@_localizer["Список останніх проєктів завантажується, зачекайте..."]</span></td>
                            </tr>
                        }
                        else if (!_recentProjectsList.Any())
                        {
                            <tr>
                                <td class="p-2"><span class="text-nowrap text-truncate">@_localizer["Список останніх проєктів пустий."]</span></td>
                            </tr>
                        }
                        else
                        {
                            foreach (var recentProjectFullPath in _recentProjectsList)
                            {
                                <tr>
                                    <td class="position-relative">
                                        <a class="stretched-link text-nowrap text-truncate" href="javascript:void(0);"
                                           @onclick="@(async () => await OpenProjectAsync(recentProjectFullPath))"
                                           data-bs-dismiss="modal"
                                        >@recentProjectFullPath</a>
                                    </td>
                                </tr>
                            }
                        }
                        @* Custom project open link *@
                        <tr>
                            <td class="position-relative">
                                <a class="text-decoration-none text-dark stretched-link" href="javascript:void(0);" data-bs-dismiss="modal" @onclick="OpenDirectoryBrowserDialogAsync">
                                    <i class="fas fa-folder-open"></i>
                                    <span>@_localizer["Відкрити інший проєкт..."]</span>
                                </a>
                            </td>
                        </tr>
                        @* /Custom project open link *@
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>

@code
{
    private List<string> _recentProjectsList = null;
    
    protected override async Task OnInitializedAsync() => _recentProjectsList = await _projectsOperator.RecentProjectsControl.GetRecentProjectsListAsync();
    
    private async Task OpenDirectoryBrowserDialogAsync()
    {
        var browserWindow = Electron.WindowManager.BrowserWindows.First();
            
        var openFolderDialogResult = await Electron.Dialog.ShowOpenDialogAsync(browserWindow, new OpenDialogOptions {
            DefaultPath = _projectsOperator.DefaultProjectsDirectoryFullPath,
            Properties = new[] { OpenDialogProperty.openDirectory },
            Title = _localizer["Щоб відкрити проєкт, оберіть директорію, у якій розміщено його файли"],
            ButtonLabel = _localizer["Відкрити проєкт"]
        });

        if (openFolderDialogResult is not { Length: > 0 } || string.IsNullOrWhiteSpace(openFolderDialogResult[0]))
            return;

        await OpenProjectAsync(openFolderDialogResult[0]);
    }
    
    private async Task OpenProjectAsync(string fullPath)
    {
        if (await _projectsOperator.CurrentProjectControl.TryOpenProjectAsync(fullPath))
        {
            _navigationManager.NavigateTo("/Project");
            StateHasChanged();
        }
        else
        {
            Electron.Dialog.ShowErrorBox(
                _localizer["Неможливо відкрити проєкт"],
                _localizer["На жаль, ми не змогли відкрити проєкт завдання за вказаним вами шляхом. Можливо, його вказано неправильно, або файли проєкту пошкоджено."]
            );
        }
    }
}